package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import java.util.ArrayList;
import java.util.List;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.mapping.sparql.factory.jena.function.AddLangTag;
import edu.fu_tdg.lodib.utils.Utils;

public class AddLangTagMappingJena extends SPARQLMapping {

	public AddLangTagMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x", varY = "?y", varZ = "?z";
		
		// Create source and target triples
		String sourceTriple1 = Utils.buildPropertyTriplePattern(varX, input.getSourceProperty(), varY);
		List<String> parameters = new ArrayList<String>();
		parameters.add(varY);
		parameters.add(Utils.createLiteralType(input.getLangTag(), null, null));
		String sourceTriple2 = Utils.buildAssignment(varZ, Utils.buildFunction(parameters, AddLangTag.URI));
		String targetTriple = Utils.buildPropertyTriplePattern(varX, input.getTargetProperty(), varZ);
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(sourceTriple1 + sourceTriple2, targetTriple);
	}

}
