package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import java.util.ArrayList;
import java.util.List;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.utils.Utils;

public class AggregationMappingJena extends SPARQLMapping {

	public AggregationMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x", varY = "?y", varZ = "?z";
		
		// Create source and target triples
		List<String> groupByVars = new ArrayList<String>();
		groupByVars.add(varX);
		String groupBy = Utils.buildGroupBy(groupByVars);
		
		List<String> selectVars = new ArrayList<String>();
		selectVars.add(varX);
		selectVars.add(Utils.buildAs(varZ, Utils.buildCount(varY)));
		
		String sourceTriple = Utils.OPEN_CURLY_BRACKET + 
					Utils.buildSPARQLSelect(
							Utils.buildRDFTypeTriplePattern(varX, input.getSourceClass()) + 
							Utils.buildPropertyTriplePattern(varX, input.getSourceProperty(), varY), 
						selectVars) + groupBy + Utils.CLOSE_CURLY_BRACKET; 
		
		String targetTriple = Utils.buildPropertyTriplePattern(varX, input.getTargetProperty(), varZ);
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(sourceTriple, targetTriple);
	}

}
