package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.utils.Utils;

public class RenameClassBasedOnPropertyMappingJena extends SPARQLMapping {

	public RenameClassBasedOnPropertyMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x", varY = "?y";
		
		// Create source and target triples
		String sourceTriple1 = Utils.buildRDFTypeTriplePattern(varX, input.getSourceClass());
		String sourceTriple2 = Utils.buildOptionalTriple(
								Utils.buildPropertyTriplePattern(varX, input.getSourceProperty(), varY));
		String sourceTriple3 = Utils.buildOptionalTriple(
								Utils.buildPropertyTriplePattern(varY, input.getSourceProperty(), varX));
		String sourceTriple4 = Utils.buildFilter(
				Utils.buildBoundVariable(varY));
		
		String targetTriple = Utils.buildRDFTypeTriplePattern(varX, input.getTargetClass());
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(sourceTriple1 + Utils.SPACE + sourceTriple2 + Utils.SPACE + sourceTriple3 + Utils.SPACE + sourceTriple4, targetTriple);
	}

}
