package edu.fu_tdg.lodib.mapping.sparql.factory.jena;

import edu.fu_tdg.lodib.mapping.InputDataTranslationMapping;
import edu.fu_tdg.lodib.mapping.sparql.SPARQLMapping;
import edu.fu_tdg.lodib.utils.Utils;

public class RenameClassBasedOnValueMappingJena extends SPARQLMapping {

	public RenameClassBasedOnValueMappingJena(InputDataTranslationMapping input) {
		super(input);
		// New variables
		String varX = "?x";
		
		// Create source and target triples
		String sourceTriple1 = Utils.buildRDFTypeTriplePattern(varX, input.getSourceClass());
		String sourceTriple2 = Utils.buildPropertyTriplePattern(varX, input.getSourceProperty(), Utils.createLiteralType(input.getValue(), input.getSourceType(), input.getNamespaces()));
		
		String targetTriple = Utils.buildRDFTypeTriplePattern(varX, input.getTargetClass());
		
		// Build SPARQL Construct
		query = Utils.buildSPARQLConstruct(sourceTriple1 + sourceTriple2, targetTriple);
	}

}
