package edu.fu_tdg.lodib.rdf_generator.literal;

import java.util.Date;
import java.util.Map;

import edu.fu_tdg.lodib.rdf_generator.distributions.Distribution;
import edu.fu_tdg.lodib.rdf_generator.distributions.UniformDistribution;
import edu.fu_tdg.lodib.utils.Utils;

public class DateGenerator implements LiteralGenerator {
	private Date minDate, maxDate;
	private String type;
	private Map<String, String> namespaces;
	
	public DateGenerator(Date minDate, Date maxDate, String type, Map<String, String> namespaces) {
		this.minDate = minDate;
		this.maxDate = maxDate;
		this.type = type;
		this.namespaces = namespaces;
	}

	public String generateValue() {
		// TODO 2: This distribution should be configurable
		Distribution<Long> dist = new UniformDistribution<Long>(minDate.getTime(), maxDate.getTime());
		Long number = dist.getValue();
		
		return Utils.createLiteralType(Utils.DATE_FORMAT.format(new Date(number)), type, namespaces);
	}
}
