package edu.fu_tdg.lodib.rdf_generator.literal;

import java.util.Map;

import edu.fu_tdg.lodib.rdf_generator.distributions.Distribution;
import edu.fu_tdg.lodib.rdf_generator.distributions.UniformDistribution;
import edu.fu_tdg.lodib.utils.Utils;

public class DoubleGenerator implements LiteralGenerator {
	private Double minValue, maxValue;
	private String type;
	private Map<String, String> namespaces;
	
	public DoubleGenerator(Double minValue, Double maxValue, String type, Map<String, String> namespaces) {
		this.minValue = minValue;
		this.maxValue = maxValue;
		this.type = type;
		this.namespaces = namespaces;
	}

	public String generateValue() {
		// TODO 2: This distribution should be configurable
		Distribution<Double> dist = new UniformDistribution<Double>(minValue, maxValue);
		Double number = dist.getValue();
		
		return Utils.createLiteralType(number.toString(), type, namespaces);
	}
}
